unit Unit0;

interface

uses
  Windows, Messages, SysUtils, Classes, Variants, Forms, Grids, Controls,
  ComObj, StrUtils, WinInet;

  {֐|߂甲}
  function dbExecCMP(strDbFile, strTmpFile: string): boolean;
  function dbCreateNew(strDbFile: string): boolean;
  function dbCnnOPEN(olvDbCnn: OleVariant; strDbFile: string): boolean;
  function dbExecQRY(olvDbCnn: OleVariant; strSQL: string): boolean;
  function dbRstOPEN(olvDbCnn, olvRst: OleVariant; strSQL: string; boolRW: boolean): boolean;
  function db0RecFound(olvDbCnn, olvRst: OleVariant; strSQL: string): boolean;
  function db0RecCnt(olvDbCnn, olvRst: OleVariant; strSQL: string): integer;
  function db0RecLookupStr(olvDbCnn, olvRst: OleVariant; strSQL, strFLD: string): string;

  function CheckSGData(sgTgt: TStringGrid): boolean;
  function CheckSGSameRec(sgTgt: TStringGrid; colKey: integer; strKEY: string): integer;
  function CnvBoolToStr(bool: boolean): string;
  function GetCntFiles(strDir: string): integer;
  function jdgStrNum(strVal: string): boolean;
  function ReadALFromTextFile(strFile: string): string;
  function TurnValFT(boolVal: boolean): boolean;
  procedure AfterDelSG(sgTgt: TStringGrid; intDelTop, intDelBtm: integer);
  procedure ClearStrGrid(sgTgt: TStringGrid);
  procedure CreateNewTXT(strFile, strWrite: string);
  procedure MoveSGData(sgFrom, sgTo: TStringGrid);
  procedure SortSGData(sgTgt, sgTMP: TStringGrid);
  procedure SGLoadALPH(sgTgt: TStringGrid; bytRptB: byte);
  procedure SGLoadKATA(sgTgt: TStringGrid; bytRptB: byte; str48: string=''; str49: string='');
  procedure SGLoadNUM(sgTgt: TStringGrid; bytRptB: byte);


  {Ep}
  function UploadKKWFiles: integer;

const
  cALPHKBD: array[0..28] of string=('Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P',
                                    '', 'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L',
                                    '', '', 'Z', 'X', 'C', 'V', 'B', 'N', 'M');
  cHKATAM: array[0..47] of string=('', '', '', '', '', '', '', '', '', '',
                                  '', '', '', '', '', '', '', '', '', '',
                                  '', '', '', '', '', '', '', '', '', '',
                                  '', '', '', '', '', '', '', '', '', '',
                                  '', '', '', '', '', '', '', '');



implementation

{֐|߂甲}

function dbExecCMP(strDbFile, strTmpFile: string): boolean;
var
  MyJRO, MyDbCnn: OleVariant;
  MyChk: boolean;
begin
  Result:=false;
  if FileExists(strDbFile)=false then begin
    exit;
  end;
  if FileExists(strTmpFile)=true then begin
    if DeleteFile(strTmpFile)=false then begin
      exit;
    end;
  end;
  Screen.Cursor:=crHourGlass;
  MyJRO:=CreateOleObject('JRO.JetEngine');
  try
    MyJRO.CompactDatabase('Provider=Microsoft.Jet.OLEDB.4.0;Data Source="' + strDbFile + '"',
                            'Provider=Microsoft.Jet.OLEDB.4.0;Data Source="' + strTmpFile + '"');
  except
    MyJRO:=Unassigned;
    Screen.Cursor:=crHourGlass;
    exit;
  end;
  MyJRO:=Unassigned;
  MyChk:=false;
  if FileExists(strDbFile)=true then begin
    if FileExists(strTmpFile)=true then begin
      MyDbCnn:=CreateOleObject('ADODB.Connection');
      if dbCnnOPEN(MyDbCnn, strTmpFile)=true then begin
        MyDbCnn.Close;
        MyChk:=true;
      end;
      MyDbCnn:=Unassigned;
      if MyChk=true then begin
        DeleteFile(strDbFile);
        RenameFile(strTmpFile, strDbFile);
      end else begin
        DeleteFile(strTmpFile);
      end;
    end;
  end;
  Screen.Cursor:=crDefault;
  Result:=MyChk;
end;

function dbCreateNew(strDbFile: string): boolean;
var
  MyADOXC: OleVariant;
begin
  Result:=false;
  if FileExists(strDbFile)=true then begin
    try
      if DeleteFile(strDbFile)=false then begin
        exit;
      end;
    except
      exit;
    end;
  end;
  MyADOXC:=CreateOleObject('ADOX.Catalog');
  try
    MyADOXC.Create('Provider=Microsoft.Jet.OLEDB.4.0;Data Source="' + strDbFile + '"');
  except
    MyADOXC:=Unassigned;
    exit;
  end;
  MyADOXC:=Unassigned;
  Result:=true;
end;

function dbCnnOPEN(olvDbCnn: OleVariant; strDbFile: string): boolean;
begin
  Result:=false;
  if FileExists(strDbFile)=false then begin
    exit;
  end;
  try
    olvDbCnn.Open('Provider=Microsoft.Jet.OLEDB.4.0;Data Source="' + strDbFile + '"');
  except
    exit;
  end;
  Result:=true;
end;

function dbExecQRY(olvDbCnn: OleVariant; strSQL: string): boolean;
begin
  Result:=false;
  try
    olvDbCnn.Execute(strSQL);
  except
    exit;
  end;
  Result:=true;
end;

function dbRstOPEN(olvDbCnn, olvRst: OleVariant; strSQL: string; boolRW: boolean): boolean;
begin
  Result:=false;
  try
    if boolRW=true then begin
      olvRst.Open(strSQL, olvDbCnn, 3, 3);
    end else begin
      olvRst.Open(strSQL, olvDbCnn);
    end;
  except
    exit;
  end;
  Result:=true;
end;

function db0RecFound(olvDbCnn, olvRst: OleVariant; strSQL: string): boolean;
begin
  Result:=false;
  if dbRstOPEN(olvDbCnn, olvRst, strSQL, false)=true then begin
    if (olvRst.BOF=false) and (olvRst.EOF=false) then begin
      Result:=true;
    end;
    olvRst.Close;
  end;
end;

function db0RecCnt(olvDbCnn, olvRst: OleVariant; strSQL: string): integer;
var
  MyCnt: integer;
begin
  MyCnt:=0;
  if dbRstOPEN(olvDbCnn, olvRst, strSQL, true)=true then begin
    if (olvRst.BOF=false) and (olvRst.EOF=false) then begin
      MyCnt:=olvRst.RecordCount;
    end;
    olvRst.Close;
  end;
  Result:=MyCnt;
end;

function db0RecLookupStr(olvDbCnn, olvRst: OleVariant; strSQL, strFLD: string): string;
var
  MyStr: string;
begin
  MyStr:='';
  if dbRstOPEN(olvDbCnn, olvRst, strSQL, false)=true then begin
    if (olvRst.BOF=false) and (olvRst.EOF=false) then begin
      try
        if VarIsNull(olvRst.Fields[strFLD].Value)=false then begin
          MyStr:=olvRst.Fields[strFLD].Value;
        end;
      except
        olvRst.Close;
        Result:=MyStr;
        exit;
      end;
    end;
    olvRst.Close;
  end;
  Result:=MyStr;
end;

function CheckSGData(sgTgt: TStringGrid): boolean;
var
  MyChk: boolean;
begin
  MyChk:=false;
  if sgTgt.RowCount=1 then begin
    if sgTgt.Cells[0, 0]<>'' then begin
      MyChk:=true;
    end;
  end else begin
    MyChk:=true;
  end;
  Result:=MyChk;
end;

function CheckSGSameRec(sgTgt: TStringGrid; colKey: integer; strKEY: string): integer;
var
  MyInt, MyInc: integer;
begin
  MyInt:=-1;
  for MyInc:=0 to sgTgt.RowCount-1 do begin
    if strKey=sgTgt.Cells[colKey, MyInc] then begin
      MyInt:=MyInc;
      Break;
    end;
  end;
  Result:=MyInt;
end;

function CnvBoolToStr(bool: boolean): string;
begin
  if bool=true then begin
    Result:='True';
  end else begin
    Result:='False';
  end;
end;

function GetCntFiles(strDir: string): integer;
var
  MySrc: TSearchRec;
  MyCnt: integer;
begin
  MyCnt:=0;
  if FindFirst(strDir + '\*.*', faAnyFile, MySrc)=0 then begin
    try
      repeat
        if (MySrc.Name<>'.') and (MySrc.Name<>'..') then begin
          MyCnt:=MyCnt + 1;
        end;
      until FindNext(MySrc)<>0;
    finally
      FindClose(MySrc);
    end;
  end;
  Result:=MyCnt;
end;

function jdgStrNum(strVal: string): boolean;
var
  MyStrVal: string;
  MyInc: byte;
begin
  if strVal='' then begin
    Result:=false;
  end else begin
    MyStrVal:=strVal;
    for MyInc:=0 to 9 do begin
      MyStrVal:=AnsiReplaceStr(MyStrVal, IntToStr(MyInc), '');
    end;
    if MyStrVal='' then begin
      Result:=true;
    end else begin
      Result:=false;
    end;
  end;
end;

function ReadALFromTextFile(strFile: string): string;
var
  MyFSO, MyTextFile: OleVariant;
  MyStrALL: string;
begin
  Result:='';
  MyStrALL:='';
  MyFSO:=CreateOleObject('Scripting.FileSystemObject');
  if MyFSO.FileExists(strFile)=true then begin
    try
      MyTextFile:=MyFSO.OpenTextFile(strFile, 1);
    except
      MyTextFile:=Unassigned;
      MyFSO:=Unassigned;
      exit;
    end;
    try
      MyStrALL:=MyTextFile.ReadAll;
    except
      MyTextFile.Close;
      MyTextFile:=Unassigned;
      MyFSO:=Unassigned;
      exit;
    end;
    MyTextFile.Close;
    MyTextFile:=Unassigned;
  end;
  MyFSO:=Unassigned;
  Result:=MyStrALL;
end;

function TurnValFT(boolVal: boolean): boolean;
begin
  if boolVal=true then begin
    Result:=false;
  end else begin
    Result:=true;
  end;
end;

procedure AfterDelSG(sgTgt: TStringGrid; intDelTop, intDelBtm: integer);
var
  MyIncX, MyIncY: integer;
begin
  with sgTgt do begin
    for MyIncY:=intDelTop to intDelBtm do begin
      for MyIncX:=0 to ColCount-1 do begin
        Cells[MyIncX, MyIncY]:='';
      end;
    end;
    if intDelBtm<RowCount-1 then begin
      for MyIncY:=0 to RowCount-intDelBtm-2 do begin
        for MyIncX:=0 to ColCount-1 do begin
          Cells[MyIncX, intDelTop + MyIncY]:=Cells[MyIncX, intDelBtm + MyIncY + 1];
        end;
        for MyIncX:=0 to ColCount-1 do begin
          Cells[MyIncX, intDelBtm + MyIncY + 1]:='';
        end;
      end;
    end;
    if RowCount=intDelBtm - intDelTop + 1 then begin
      RowCount:=1;
    end else begin
      RowCount:=RowCount - (intDelBtm - intDelTop + 1);
    end;
  end;
end;

procedure ClearStrGrid(sgTgt: TStringGrid);
var
  MyIncCL, MyIncRW: integer;
begin
  with sgTgt do begin
    for MyIncRW:=0 to RowCount-1 do begin
      for MyIncCL:=0 to ColCount-1 do begin
        Cells[MyIncCL, MyIncRW]:='';
      end;
    end;
    RowCount:=1;
    Col:=0;
    Row:=0;
  end;
end;

procedure CreateNewTXT(strFile, strWrite: string);
var
  MyFSO, MyTextFile: OleVariant;
begin
  MyFSO:=CreateOleObject('Scripting.FileSystemObject');
  MyTextFile:=MyFSO.CreateTextFile(strFile, true);
  if strWrite<>'' then begin
    MyTextFile.Write(strWrite);
  end;
  MyTextFile.Close;
  MyTextFile:=Unassigned;
  MyFSO:=Unassigned;
end;

procedure MoveSGData(sgFrom, sgTo: TStringGrid);
var
  MyIncCL, MyIncRW: integer;
begin
  sgTo.RowCount:=sgFrom.RowCount;
  for MyIncRW:=0 to sgFrom.RowCount-1 do begin
    for MyIncCL:=0 to sgFrom.ColCount-1 do begin
      sgTo.Cells[MyIncCL, MyIncRW]:=sgFrom.Cells[MyIncCL, MyIncRW];
    end;
  end;
  ClearStrGrid(sgFrom);
end;

procedure SortSGData(sgTgt, sgTMP: TStringGrid);
var
  MyIncCL, MyIncRW: integer;
begin
  sgTMP.RowCount:=sgTgt.RowCount;
  for MyIncRW:=0 to sgTgt.RowCount-1 do begin
    for MyIncCL:=0 to sgTgt.ColCount-1 do begin
      sgTMP.Cells[MyIncCL, MyIncRW]:=sgTgt.Cells[MyIncCL, sgTgt.RowCount-1-MyIncRW];
    end;
  end;
  MoveSGData(sgTMP, sgTgt);
  ClearStrGrid(sgTMP);
  sgTgt.Perform(WM_VSCROLL, MakeWParam(SB_TOP, 0), 0);
  sgTgt.Perform(WM_VSCROLL, MakeWParam(SB_ENDSCROLL, 0), 0);
end;

procedure SGLoadALPH(sgTgt: TStringGrid; bytRptB: byte);
var
  MyNumCol, MyNumRow: byte;
  MyInc: byte;
  MyStrB: string;
begin
  MyStrB:='';
  for MyInc:=1 to bytRptB do begin
    MyStrB:=MyStrB + ' ';
  end;
  for MyInc:=0 to 28 do begin
    MyNumCol:=MyInc Mod 10;
    MyNumRow:=MyInc div 10;
    sgTgt.Cells[MyNumCol, MyNumRow]:=MyStrB + cALPHKBD[MyInc];
  end;
end;

procedure SGLoadKATA(sgTgt: TStringGrid; bytRptB: byte; str48: string=''; str49: string='');
var
  MyNumCol, MyNumRow: byte;
  MyInc: byte;
  MyStrB: string;
begin
  MyStrB:='';
  for MyInc:=1 to bytRptB do begin
    MyStrB:=MyStrB + ' ';
  end;
  for MyInc:=0 to 47 do begin
    MyNumCol:=MyInc div 5;
    MyNumRow:=MyInc mod 5;
    sgTgt.Cells[MyNumCol, MyNumRow]:=MyStrB + cHKATAM[MyInc];
  end;
  sgTgt.Cells[9, 3]:=str48;
  sgTgt.Cells[9, 4]:=str49;
end;

procedure SGLoadNUM(sgTgt: TStringGrid; bytRptB: byte);
var
  MyInc: byte;
  MyStrB: string;
begin
  MyStrB:='';
  for MyInc:=1 to bytRptB do begin
    MyStrB:=MyStrB + ' ';
  end;
  for MyInc:=0 to 9 do begin
    sgTgt.Cells[MyInc, 0]:=MyStrB + RightStr(IntToStr(MyInc + 1), 1);
  end;
end;






function UploadKKWFiles: integer; {Ep}
  function IsBinaryFile(strFile: string): boolean;
  const
    MyReadSize=255;
  var
    MyChkFile: file;
    MyReadNum, MyInc, MyCtrlCnt, MyIntOrd: integer;
    MyReadBuf: array [0..MyReadSize] of Char;
  begin
    Result:=False;
    AssignFile(MyChkFile,strFile);
    Reset(MyChkFile,1);
    BlockRead(MyChkFile, MyReadBuf, MyReadSize, MyReadNum);
    CloseFile(MyChkFile);
    MyCtrlCnt:=0;
    for MyInc:=0 to MyReadNum do begin
      MyIntOrd:=Ord(MyReadBuf[MyInc]);
      if (MyIntOrd in [0..31, 127, 253..255]) and not (MyIntOrd in [9..13, 32]) then begin
        Inc(MyCtrlCnt);
      end;
      if MyCtrlCnt>5 then begin
        Result:=True;
      end;
    end;
  end;
  function SrcRmvDrv: string;
  const
    cRMVDRV: array[0..22] of string = ('D', 'E', 'F', 'G', 'H', 'I', 'J', 'K',
                                        'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S',
                                        'T', 'U', 'V', 'W', 'X', 'Y', 'Z');
  var
    MyFSO, MyDRV: OleVariant;
    MyStrDRV: string;
    MyIntMin, MyIntMax: Int64;
    MyInc: integer;
  begin
    MyIntMax:=8000000000;
    MyIntMin:=64000000;
    MyStrDRV:='';
    MyFSO:=CreateOleObject('Scripting.FileSystemObject');
    for MyInc:=0 to 22 do begin
      if MyFSO.FolderExists(cRMVDRV[MyInc] + ':')=true then begin
        try
          MyDRV:=MyFSO.GetDrive(cRMVDRV[MyInc]);
          if MyDRV.DriveType=1 then begin
            if MyDRV.TotalSize<=MyIntMax then begin
              if MyDRV.TotalSize>=MyIntMin then begin
                MyStrDRV:=cRMVDRV[MyInc] + ':\';
              end;
            end;
          end;
          MyDRV:=Unassigned;
        except
          MyDRV:=Unassigned;
        end;
      end;
      if MyStrDrv<>'' then begin
        Break;
      end;
    end;
    MyFSO:=Unassigned;
    Result:=MyStrDRV;
  end;
var
  MyStrLine: array[0..8] of string;
  MyLines: TStringList;
  MyStrALL: string;
  MyStrRmvDRV, MyStrAppExePath: string;
  MyStrSvr, MyStrAcnt, MyStrPWD, MyStrDst0, MyStrDst1: string;
  MyStrFile: array[0..3] of string;
  MyInc, MyIntMAX, MyCnt: integer;
  MyFSO: OleVariant;
  MyCnnINET, MyCnnFTP: HINTERNET;
begin
  MyStrAppExePath:=ExtractFilePath(Application.ExeName);
  for MyInc:=0 to 8 do begin
    MyStrLine[MyInc]:='';
  end;
  MyStrALL:=ReadALFromTextFile(MyStrAppExePath + 'kkwst.txt');
  if MyStrALL<>'' then begin
    MyLines:=TStringList.Create;
    try
      MyLines.Text:=MyStrALL;
      MyIntMAX:=MyLines.Count-1;
      if MyIntMAX>8 then begin
        MyIntMAX:=8;
      end;
      for MyInc:=0 to MyIntMAX do begin
        MyStrLine[MyInc]:=MyLines[MyInc];
      end;
    finally
      MyLines.Free;
    end;
  end;
  MyStrSvr:=MyStrLine[0];
  MyStrAcnt:=MyStrLine[1];
  MyStrPWD:=MyStrLine[2];
  MyStrDst0:=MyStrLine[3];
  MyStrDst1:=MyStrLine[4];
  for MyInc:=0 to 3 do begin
    MyStrFile[MyInc]:=MyStrLine[MyInc+5]
  end;
  if (MyStrSvr='') or (MyStrAcnt='') or (MyStrPWD='') or (MyStrDst0='')  or (MyStrDst1='') then begin
    Result:=1;
    exit;
  end;
  MyStrRmvDRV:=SrcRmvDrv;
  if MyStrRmvDRV='' then begin
    Result:=2;
    exit;
  end;
  MyCnt:=0;
  MyFSO:=CreateOleObject('Scripting.FileSystemObject');
  for MyInc:=0 to 3 do begin
    if MyStrFile[MyInc]<>'' then begin
      if MyFSO.FileExists(MyStrRmvDRV + MyStrFile[MyInc])=true then begin
        if MyFSO.FileExists(MyStrAppExePath + MyStrFile[MyInc])=true then begin
          MyFSO.DeleteFile(MyStrAppExePath + MyStrFile[MyInc])
        end;
        MyFSO.CopyFile(MyStrRmvDRV + MyStrFile[MyInc], MyStrAppExePath + MyStrFile[MyInc]);
        MyCnt:=MyCnt + 1;
      end;
    end;
  end;
  if MyFSO.FileExists(MyStrAppExePath + 'adrlist.mdb') then begin
    MyFSO.CopyFile(MyStrAppExePath + 'adrlist.mdb', MyStrRmvDRV + 'adrlist.mdb');
  end;
  MyFSO:=Unassigned;
  if MyCnt=0 then begin
    Result:=3;
    exit;
  end;
  Result:=4;
  MyCnnINET:=InternetOpen(nil, INTERNET_OPEN_TYPE_DIRECT, nil, nil, 0);
  if Assigned(MyCnnINET) then begin
    MyCnnFTP:=InternetConnect(MyCnnINET,
                              PChar(MyStrSvr),
                              INTERNET_DEFAULT_FTP_PORT,
                              PChar(MyStrAcnt),
                              PChar(MyStrPWD),
                              INTERNET_SERVICE_FTP, 0, 0);
    if Assigned(MyCnnFTP) then begin
      for MyInc:=0 to 2 do begin
        if FileExists(MyStrAppExePath + MyStrFile[MyInc]) then begin
          if IsBinaryFile(MyStrAppExePath + MyStrFile[MyInc]) then begin
            FtpPutFile(MyCnnFTP,
                      PChar(MyStrAppExePath + MyStrFile[MyInc]),
                      PChar(MyStrDst1 + MyStrFile[MyInc]),
                      FTP_TRANSFER_TYPE_BINARY, 0);
          end else begin
            FtpPutFile(MyCnnFTP,
                      PChar(MyStrAppExePath +MyStrFile[MyInc]),
                      PChar(MyStrDst0 + MyStrFile[MyInc]),
                      FTP_TRANSFER_TYPE_ASCII, 0);
          end;
        end;
      end;
      Result:=0;
      InternetCloseHandle(MyCnnFTP);
    end;
    InternetCloseHandle(MyCnnINET);
  end;
end;

end.
